# -*-coding:Latin-1 -*
# # # # # # BEGIN GPL BLOC DE LICENCE # # # # # 		 Menuiseries Ver3  11/02/2014
# 
# Ce programme est un logiciel libre; vous pouvez le redistribuer et / ou 
# Modifier selon les termes de la Licence Publique Generale GNU 
# Publie par la Free Software Foundation, version 2 
# De la Licence, ou (a votre choix) toute version ulterieure. 
# 
# Ce programme est distribue dans l'espoir qu'il sera utile, 
# Mais SANS AUCUNE GARANTIE, sans meme la garantie implicite de 
# COMMERCIALISATION ou D'ADAPTATION A UN USAGE PARTICULIER. voir l'
# GNU General Public License pour plus de details. 
# 
# Vous devriez avoir recu une copie de la GNU General Public License 
# Avec ce programme, sinon, ecrivez a la Free Software Foundation, 
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.                                                 

bl_info = {
    "name": "Menuiseries",
    "author": "michel martinoia",
    "version": (3,0),
    "blender": (2,64),
    "api": "",
    "location": "View3D > Add > Mesh > Menuiseries",
    "description": "Creer Menuiseries",
    "warning": "",
    "wiki_url": "",
    "tracker_url": "",
    "category": "Add Mesh"}
import bpy
from bpy.props import *

def Valr(s):
    if  s.Valr=='1':                  
        s.nVtx=1; s.nImp=0 # 60x60 Frappe 1 Vtl
        s.All0= 90; s.AllVi= 0; s.AllViC= False  # Rectifier Si s.AllViC= True Avant 
        s.hdA= 6; s.lgM0= 5                    # Rectifier Si PF hdA= 2 Avant                    
        s.XoT=60; s.Xo0=60; s.ZoAff=60; s.Zoi= 0 
        s.Choix= '1V F-PF' 
    if  s.Valr=='2':           # 180x130 Frappe 2 Vtx
        s.nVtx=2 ;s.nImp=0
        s.All0=90; s.All1= 90; s.AllVi=0; s.AllViC= False           
        s.hdA= 6              # s.lgd=5; s.epd=5;             
        s.XoT=180; s.Xo0=90; s.Xo1=90; s.Zo0=130; s.Zo1=130; s.Zoi= 0
        s.Choix= '2V F-PF'
    if  s.Valr=='3':           # 205x220 Frappe 3 Vtx All Vitre    
        s.nVtx=3; s.nImp=1
        s.All0= 90; s.All1= 0; s.All2= 90; s.AllVi= 90; s.AllViC= True
        s.hdA= 6         # s.lgd=5; s.epd=5; 
        s.XoT= 305; s.Xo0=102.5; s.Xo1=100; s.Xo2=102.5
        s.Zo0= 130; s.Zo1= 220; s.Zo2= 130; s.Zoi= 40   
        s.Choix= '3V 2F-1PF'
    if  s.Valr=='4':           # 405x220 Frappe 4 Vtx     
        s.nVtx=4; s.nImp=0;
        s.All0= 0; s.All1= 0; s.All2= 0; s.All3= 0; s.AllVi= 90; s.AllViC= False
        s.hdA= 2              # s.lgd=5; s.epd=5; 
        s.XoT= 405; s.Xo0=102.5; s.Xo1=100; s.Xo2=100; s.Xo3=102.5
        s.Zo0= 220; s.Zo1= 220; s.Zo2= 220; s.Zo3= 220; s.Zoi= 0   
        s.Choix= '4V PF-F'
    if  s.Valr=='5':           # 505x220 Frappe 5 Vtx 2 PF, 3 F  
        s.nVtx=5; s.nImp=1;
        s.All0= 90; s.All1= 0; s.All2= 90; s.All3= 10; s.All4= 90; s.AllVi= 90; s.AllViC= False
        s.hdA= 6
        s.XoT= 505; s.Xo0=102.5; s.Xo1=100; s.Xo2=100; s.Xo3=100; s.Xo4=102.5
        s.Zo0= 130; s.Zo1= 220; s.Zo2= 130; s.Zo3= 210; s.Zo4= 130; s.Zoi= 40 
        s.Choix= '5V 3F-2PF'
    if  s.Valr=='6':           # 505x220 Frappe 5 Vtx 3 PF, 2 F     
        s.nVtx=5; s.nImp=1;
        s.All0= 0; s.All1= 90; s.All2= 0; s.All3= 90; s.All4= 0; s.AllVi= 90; s.AllViC= False
        s.hdA= 6
        s.XoT= 505; s.Xo0=102.5; s.Xo1=100; s.Xo2=100; s.Xo3=100; s.Xo4=102.5
        s.Zo0= 220; s.Zo1= 130; s.Zo2= 220; s.Zo3= 130; s.Zo4= 220; s.Zoi= 40 
        s.Choix= '5V 3PF-2F'
    if  s.Valr=='7':           # 505x220 Frappe 5 Vtx 1 PF-3 F-1 PF   
        s.nVtx=5; s.nImp=1;
        s.All0= 0; s.All1= 90; s.All2= 90; s.All3= 90; s.All4= 0; s.AllVi= 90; s.AllViC= False
        s.hdA= 6
        s.XoT= 505; s.Xo0=102.5; s.Xo1=100; s.Xo2=100; s.Xo3=100; s.Xo4=102.5
        s.Zo0= 220; s.Zo1= 130; s.Zo2= 130; s.Zo3= 130; s.Zo4= 220; s.Zoi= 40 
        s.Choix= '5V 1PF-3F-1PF'
    if  s.Valr=='8':           # 505x220 Frappe 5 Vtx 5 F en Escalier Allege HAUT a Gche, BAS a Dte OK  
        s.nVtx=5; s.nImp=1;
        s.All0= 90; s.All1= 68; s.All2= 45; s.All3= 23; s.All4= 0; s.AllVi= 90; s.AllViC= False
        s.hdA= 6
        s.XoT= 505; s.Xo0=102.5; s.Xo1=100; s.Xo2=100; s.Xo3=100; s.Xo4=102.5
        s.Zo0= 130; s.Zo1= 152; s.Zo2= 175; s.Zo3= 197; s.Zo4= 220; s.Zoi= 40    
        s.Choix= '5FPFesc_HgBd'
    if  s.Valr=='9':           # 505x220 Frappe 5 Vtx 5 F en Escalier Allege BAS a Gche, HAUT a Dte  
        s.nVtx=5; s.nImp=1;
        s.All0= 0; s.All1= 23; s.All2= 45; s.All3= 68; s.All4= 90 #; s.AllVi= 80; s.AllViC= True
        s.hdA= 6
        s.XoT= 505; s.Xo0=102.5; s.Xo1=100; s.Xo2=100; s.Xo3=100; s.Xo4=102.5
        s.Zo0= 220; s.Zo1= 197; s.Zo2= 175; s.Zo3= 152; s.Zo4= 130; s.Zoi= 40 
        s.Choix= '5FPFesc_BgHd'        
    if  s.Valr=='10':           # 505x220 Frappe 5 Vtx 5 F en Escalier Allege BAS a Gche, HAUT a Dte, Meno+Lint  
        s.nVtx=5; s.nImp=1;
        s.All0= 0; s.All1= 10; s.All2= 45; s.All3= 68; s.All4= 0 #; s.AllVi= 80; s.AllViC= True
        s.OuvTyp0= '2'; s.OuvTyp1= '2'; s.OuvTyp2= '2'; s.OuvTyp3= '4'; s.OuvTyp4= '2'
        s.AllVi= 90; s.AllViC= True; s.GdeCC= True; s.YoC= True; s.hdA= 6
        s.XoT= 505; s.Xo0=102.5; s.Xo1=100; s.Xo2=100; s.Xo3=100; s.Xo4=102.5        
        s.Zo0= 220; s.Zo1= 195; s.Zo2= 145; s.Zo3= 108; s.Zo4= 220; s.Zoi= 40
        s.epM0= 10; s.epM1= 15; s.epM2= 20; s.epM3= 25; s.lgM0= 10; s.lgM1= 15; s.lgM2= 20; s.lgM3= 25  
        s.Choix= '5FPFesc_BgHd MenoLint'         
    if  s.Valr=='11':           # 505x220 Inegaux  
        s.nVtx=5; s.nImp=1;
        s.All0= 0; s.All1= 90; s.All2= 90; s.All3= 90; s.All4= 0; s.AllVi= 80; s.AllViC= False
        s.hdA= 6
        s.XoT= 505; s.Xo0=52.5; s.Xo1=80; s.Xo2=170; s.Xo3=120; s.Xo4=62.5
        s.Zo0= 220; s.Zo1= 130; s.Zo2= 130; s.Zo3= 130; s.Zo4= 220; s.Zoi= 40
        s.Choix= '5V Inegaux'             
    print("   ")    
    print("s.Choix=", s.Choix)     
#-------------------

def MatC(Nom,R,V,B):
    if Nom not in bpy.data.materials:
        Matr=bpy.data.materials.new(Nom)
        Matr.diffuse_color= ([R,V,B])
        Matr.diffuse_shader= 'LAMBERT'
        Matr.diffuse_intensity= 1.0
    else:
        Matr=bpy.data.materials[Nom]
    return Matr           
#------------------------------------------------------------------------

def Ouvrant(vrtx, fac, hTt, hTtG, hTtD, lgd, hdA, lgO, hOA, nivZ, fEx, fIn, All, basZE, basZI, basZ, TourD= 1):   
    Arrond= round(nivZ-lgO,2)  
    vrtx.extend([[hTtG, fEx, basZE],[hTtD, fEx, basZE],[hTtD-lgO, fEx, basZI],[hTtG+lgO, fEx, basZI]])  
    vrtx.extend([[hTtD, fEx, nivZ],[hTtG, fEx, nivZ],[hTtG+lgO, fEx, Arrond],[hTtD-lgO, fEx, Arrond]]) 
    vrtx.extend([[hTtG, fIn, basZE],[hTtD, fIn, basZE],[hTtD-lgO, fIn, basZI],[hTtG+lgO, fIn, basZI]])     
    vrtx.extend([[hTtD, fIn, nivZ],[hTtG, fIn, nivZ],[hTtG+lgO, fIn, Arrond],[hTtD-lgO, fIn, Arrond]]) 
    n= len(vrtx) 
    FacesConcat(vrtx, fac, n, TourD)       
#----------------------------------------
    
def GdLoup(vrtx, fac, hTC, fEx, basZE, nivZ): 
    hTtG= hTC- .02; hTtD= hTC+ .02
    vrtx.extend([[hTtG, fEx- .013, basZE],[hTtD, fEx- .013, basZE],[hTtD, fEx- .013, nivZ],[hTtG, fEx- .013, nivZ]]) 
    vrtx.extend([[hTtG, fEx, basZE],[hTtD, fEx, basZE],[hTtD, fEx, nivZ],[hTtG, fEx, nivZ]]) # vrtx Colles/Ouv
    n= len(vrtx)     
    fac.extend([[n-8, n-7, n-6, n-5],[n-8, n-5, n-1, n-4],[n-3, n-2, n-6, n-7]]) # Fac Avt, Gche, Droit 
    m= len(fac) 
  
#----------------------------------------   
def FacesConcat(vrtx, fac, n, TourD):
    fac.extend([[n-16, n-15, n-14, n-13],[n-12, n-11, n-10, n-9],[n-16, n-13, n-10, n-11],[n-12, n-9, n-14, n-15]])          
    fac.extend([[n-8, n-7, n-6, n-5],[n-4, n-3, n-2, n-1],[n-8, n-5, n-2, n-3],[n-4, n-1, n-6, n-7]])      
    fac.extend([[n-14, n-6, n-5, n-13],[n-10, n-2, n-1, n-9],[n-10, n-13, n-5, n-2],[n-14, n-9, n-1, n-6]])                
    if TourD== 1:        
        fac.extend([[n-16, n-15, n-7, n-8],[n-12, n-4, n-3, n-11],[n-16, n-11, n-3, n-8],[n-15, n-7, n-4, n-12]]) # Entourage
        m=len(fac)    
        
#----------------------------------------------
def Meneau(vrtx, fac, nfacGdC, Gc, Dt, fEx, fIn, lgd, epd, lgM, epM, hdA, basZ, nivZ, GdC): # 8 vrtx, 4 fac Htr
    if GdC== 0:
        fEx= fIn- epM 
    Arrond= round(nivZ, 2); tmp= basZ     
    n= 0
    vrtx.extend([[Gc, fEx, tmp],[Dt, fEx, tmp],[Dt, fEx, Arrond],[Gc, fEx, Arrond]]) 
    vrtx.extend([[Gc, fIn, tmp],[Dt, fIn, tmp],[Dt, fIn, Arrond],[Gc, fIn, Arrond]]) 
    n= len(vrtx) 
    fac.extend([[n-8, n-7, n-6, n-5],[n-4, n-3, n-2, n-1],[n-8, n-5, n-1, n-4],[n-7, n-3, n-2, n-6]])
    if GdC== 1:
        nf= len(fac); nfacGdC.extend([nf-1, nf-2, nf-3, nf-4]); nfGdC=len(nfacGdC)          

#--------------------------------
def AppuiSeuil(vrtx, fac, hTtG, hTtD, fEx, basZE, Rep):
    n= 0
    if Rep== 0:  
        hNzAr= .04; NezLg= .04
    elif Rep== 1:  
        hNzAr= .03; NezLg= .04
    NezAv= .02;               
    vrtx.extend([[hTtG, fEx-NezLg, basZE],[hTtD, fEx-NezLg, basZE],[hTtD, fEx-NezLg, basZE+ NezAv],[hTtG, fEx- NezLg, basZE+ NezAv]])
    vrtx.extend([[hTtD, fEx, basZE+ hNzAr],[hTtG, fEx, basZE+ hNzAr]]) # 2 vrtx Ht / Face Pentue 
    n= len(vrtx) 
    fac.extend([[n-6, n-5, n-4, n-3],[n-3, n-4, n-2, n-1]]) # Appui 0 a 5= 6 vrtx, 2 faces

#------------------------------
def Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep): # Verre/F1V, F2V, C2V     
    n= 0     
    if Rep== 1:    
        Les2= epO/2
    if Rep== 3:      
        Les2= epOC/2 
    if Rep== 1 or Rep== 3:
        Arrond= round(nivZ-lgO,2)                   
        vrtx.extend([[hTtD-lgO, fEx+ Les2, basZI],[hTtD-lgO, fEx+ Les2, Arrond],[hTtG+lgO, fEx+ Les2, Arrond],[hTtG+lgO, fEx+ Les2, basZI]])
        n= len(vrtx)       
    elif Rep== 0:                  
        vrtx.extend([[hTtG, fEx+ epd/2, basZE],[hTtD, fEx+ epd/2, basZE],[hTtD, fEx+ epd/2,nivZ],[hTtG, fEx+ epd/2, nivZ]])
        n= len(vrtx)                          
    fac.extend([[n-4, n-3, n-2, n-1]])
    nf= len(fac); nfacVit.extend([nf-1]); nfVit=len(nfacVit) 
    
#-------------------------------------
def Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC): 
    n= 0 #        
    vrtx.extend([[hTtG, fEx, basZ],[hTtD, fEx, basZ],[hTtD, fEx, nivZ],[hTtG, fEx, nivZ]]) 
    vrtx.extend([[hTtG, fIn, basZ],[hTtD, fIn, basZ],[hTtD, fIn, nivZ],[hTtG, fIn, nivZ]]) 
    n= len(vrtx) 
    fac.extend([[n-8, n-7, n-6, n-5],[n-4, n-3, n-2, n-1],[n-8, n-4, n-3, n-7],[n-5, n-6, n-2, n-1]])        
    if GdC== 1:
        nf= len(fac); nfacGdC.extend([nf-1, nf-2, nf-3, nf-4]); nfGdC=len(nfacGdC)    

# -------------------------- PM: All= 0.9 et self.All= 90
def CreObjet(self, context):                         
    vrtx=[]; fac=[]; lVtx=[]; lFac=[]; lVtx= []; lFac= []
    lV0=[]; lOdes= []; lIdes= []
    nfacVit= []; nfacGdC= []; nfMurTbl= []
    lAll= []; lZo= []; lAllVi= []; lAllViC= []; lGdeC= []; lGdeCC= []; llgM= []; lepM= []    
    hTt= (self.XoT/100)/2  
    lgd= self.lgd/100; epd= self.epd/100; hdA= self.hdA/100 
    lgO= self.lgO/100; epO= self.epO/100; epOC= self.epOC/100; hOA= self.hOA/100        
    All= self.All/100; lMur= self.Yo/100 
    AllVi= self.AllVi/100; AllViC= self.AllViC
    nVtx= self.nVtx
    if self.OuvTyp0=='3' or self.OuvTyp1=='3' or self.OuvTyp2=='3' or self.OuvTyp3=='3' or self.OuvTyp4=='3': # Init epDormant 
        epd= .08; self.epd= epd*100; epOC= .035; self.epO= epOC*100               
    else:
       epd= .05; epO= .05; self.epd= epd*100; self.epO= epO*100                                      
    fEx= lMur- epd; fIn= lMur
    Zoi= self.Zoi/100    
    basZ= All  # Voir Calcul/Adapt/def Ouvrant
    nivZ= All+ (self.ZoAff/100)
    nImp= self.nImp 
    nivLint= All+ (self.ZoAff/100)+ Zoi 
    nivLintFPF= self.nivLintFPF/100 
    if nImp== 1:
        nivZ= nivLint
    Axe= 0
    if self.AllIdem== True:
        self.All1= self.All0; self.All2= self.All0; self.All3= self.All0; self.All4= self.All0            
    if self.hZoIdem== True:
        self.Zo1= self.Zo0; self.Zo2= self.Zo0; self.Zo3= self.Zo0; self.Zo4= self.Zo0 

    lAllVi= ([0, 0, 0, 0, 0])
    lAllViC= ([False, False, False, False, False])
    lGdeC= ([1, 1, 1, 1, 1])
    lGdeCC= ([False, False, False, False, False])
    lgM= self.lgM/100; lgM0= self.lgM0/100; lgM1= self.lgM1/100; lgM2= self.lgM2/100; lgM3= self.lgM3/100; lgM4= self.lgM4/100
    llgM.extend([lgM0, lgM1, lgM2, lgM3, lgM4]) #  
    epM= self.epM/100; epM0= self.epM0/100; epM1= self.epM1/100; epM2= self.epM2/100; epM3= self.epM3/100; epM4= self.epM4/100   
    lepM.extend([epM0, epM1, epM2, epM3, epM4]) # 

    if self.Egalise== '2':         
        Axe= (self.XoT - lgd*100) / nVtx; Axe= round((Axe),3) 
        if nVtx== 1:
            self.Xo0= self.XoT
        if nVtx== 2:
            self.Xo0= self.XoT/2; self.Xo1= self.XoT/2 
        if nVtx== 3:
            self.Xo0= (lgd*100)/2+Axe; self.Xo1= Axe; self.Xo2= Axe+(lgd*100/2)  # Idem      
        if nVtx== 4:
            self.Xo0= (lgd*100)/2+ Axe; self.Xo1= Axe; self.Xo2= Axe; self.Xo3= Axe+(lgd*100/2)
        if nVtx== 5:
            self.Xo0= (lgd*100)/2+ Axe; self.Xo1= Axe; self.Xo2= Axe; self.Xo3= Axe; self.Xo4= Axe+(lgd*100/2)           
    if self.Egalise== '1':        
        if nVtx== 1:
            self.XoT= self.Xo0  
        if nVtx== 2:
            self.XoT= self.Xo0 + self.Xo1
        if nVtx== 3:
            self.XoT= self.Xo0 + self.Xo1 + self.Xo2          
        if nVtx== 4:
            self.XoT= self.Xo0 + self.Xo1 + self.Xo2 + self.Xo3     
        if nVtx== 5: 
            self.XoT= self.Xo0 + self.Xo1 + self.Xo2 + self.Xo3 + self.Xo4
        hTt= self.XoT/100/2   
    
    if self.Egalise== '0':          
        ResteXon= 0        
        if nVtx== 1:  
            self.XoT= self.Xo0
        if nVtx== 2:                            
            if self.XoT < self.Xo0 + self.Xo1: 
                ResteXon= self.XoT- self.Xo1 
                if ResteXon >= 20:                                
                    self.Xo0= self.XoT- self.Xo1               
                elif ResteXon < 20: 
                    self.XoT= self.Xo0 + self.Xo1 
            else: 
                self.Xo0= self.XoT- self.Xo1                                    
        if nVtx== 3:                              
            if self.XoT < self.Xo0 + self.Xo1 + self.Xo2 + self.Xo3 + self.Xo4: 
                ResteXon= self.XoT- (self.Xo0+ self.Xo2) 
                if ResteXon >= 20:                                
                    self.Xo1= self.XoT- (self.Xo0+ self.Xo2)               
                elif ResteXon < 20:
                    self.XoT= self.Xo0 + self.Xo1 + self.Xo2 
            else: 
                self.Xo1= self.XoT- (self.Xo0+ self.Xo2)                        
        if nVtx== 4:          
            if self.XoT < self.Xo0 + self.Xo1 + self.Xo2 + self.Xo3: 
                ResteXon= self.XoT- (self.Xo1+ self.Xo2+ self.Xo3) 
                if ResteXon >= 20:                              
                    self.Xo0= self.XoT- (self.Xo1+ self.Xo2+ self.Xo3)               
                elif ResteXon < 20: 
                    self.XoT= self.Xo0 + self.Xo1 + self.Xo2 + self.Xo3 
            else: 
                self.Xo0= self.XoT- (self.Xo1+ self.Xo2+ self.Xo3)                         
        if nVtx== 5:          # Xo2 du Centre qui Varie                     
            if self.XoT < self.Xo0 + self.Xo1 + self.Xo2 + self.Xo3 + self.Xo4: 
                ResteXon= self.XoT- (self.Xo0+ self.Xo1+ self.Xo3+ self.Xo4) 
                if ResteXon >= 20:                                
                    self.Xo2= self.XoT- (self.Xo0+ self.Xo1+ self.Xo3+ self.Xo4)                
                elif ResteXon < 20: 
                    self.XoT= self.Xo0 + self.Xo1 + self.Xo2 + self.Xo3 + self.Xo4 
            else: 
                self.Xo2= self.XoT- (self.Xo0+ self.Xo1+ self.Xo3+ self.Xo4)                
        hTt= self.XoT/100/2 
                                                               
    lXo=[]  
    if nVtx== 1:           
        lXo.extend([-hTt+ self.Xo0/100- lgd/2])
        lAll.extend([self.All0/100])
        lZo.extend([self.Zo0/100])
    if nVtx== 2:       
        lXo.extend([-hTt+self.Xo0/100]) 
        lAll.extend([self.All0/100, self.All1/100])
        lZo.extend([self.Zo0/100, self.Zo1/100])
    if nVtx== 3:      
        lXo.extend([-hTt+self.Xo0/100, -hTt+self.Xo0/100+self.Xo1/100]) 
        lAll.extend([self.All0/100, self.All1/100, self.All2/100])
        lZo.extend([self.Zo0/100, self.Zo1/100, self.Zo2/100])
    if nVtx== 4:             
        lXo.extend([-hTt+self.Xo0/100, -hTt+self.Xo0/100+self.Xo1/100, -hTt+self.Xo0/100+self.Xo1/100+self.Xo2/100]) 
        lAll.extend([self.All0/100, self.All1/100, self.All2/100, self.All3/100])
        lZo.extend([self.Zo0/100, self.Zo1/100, self.Zo2/100, self.Zo3/100])
    if nVtx== 5:             
        lXo.extend([-hTt+self.Xo0/100,-hTt+self.Xo0/100+self.Xo1/100,-hTt+self.Xo0/100+self.Xo1/100+self.Xo2/100,-hTt+self.Xo0/100+self.Xo1/100+self.Xo2/100+self.Xo3/100])    
        lAll.extend([self.All0/100, self.All1/100, self.All2/100, self.All3/100, self.All4/100])
        lZo.extend([self.Zo0/100, self.Zo1/100, self.Zo2/100, self.Zo3/100, self.Zo4/100])
    if nVtx > 1:
        lXo.extend([hTt- lgd/2])
             
    if self.nivLintFPFC== True:
        for i in range(0, nVtx): 
            lZo[i]= nivLintFPF- lAll[i] 
            if i== 0:
                self.Zo0= lZo[0]*100
            if i== 1:
                self.Zo1= lZo[1]*100
            if i== 2:
                self.Zo2= lZo[2]*100
            if i== 3:
                self.Zo3= lZo[3]*100
            if i== 4:
                self.Zo4= lZo[4]*100                                            

    if self.lgMepM== True: 
        lgM= .05; lgM0= .05; lgM1= .05; lgM2= .05; lgM3= .05         
        epM= .05; epM0= .05; epM1= .05; epM2= .05; epM3= .05        
        for i in range(0, nVtx):            
            llgM[i]= .05; lepM[i]= .05
    if self.lgMepM8== True: 
        lgM= .05; lgM0= .05; lgM1= .05; lgM2= .05; lgM3= .05        
        epM= .08; epM0= .08; epM1= .08; epM2= .08; epM3= .08
        for i in range(0, nVtx):            
            llgM[i]= .05; lepM[i]= .08
    if self.lgMepM== True or self.lgMepM8== True:
        self.lgM= lgM*100; self.lgM0= lgM0*100; self.lgM1= lgM1*100; self.lgM2= lgM2*100; self.lgM3= lgM3*100; self.lgM4= lgM4*100  
        self.epM= epM*100; self.epM0= epM0*100; self.epM1= epM1*100; self.epM2= epM2*100; self.epM3= epM3*100; self.epM4= epM4*100     
           
    lbasZ=[]; lbasZAl=([0,0,0,0,0]); lAraMx=([0,0,0,0,0]); lSouMx=([0,0,0,0,0])
    lLintR= ([99,99,99,99,99,99,99,99,99,99])
    lbasZ.extend([self.All0/100, self.All1/100, self.All2/100, self.All3/100, self.All4/100])
  
    lbasZ[0]= lAll[0]   
    for i in range(1, nVtx):
        if lAll[i]== lAll[i-1]:  
            lbasZ[i-1]= lAll[i-1]     
            lbasZAl[i-1]= 'no'
        if lAll[i] > lAll[i-1]:
            lbasZ[i-1]= lAll[i-1]
            lbasZAl[i-1]= lAll[i]                                
        if lAll[i] < lAll[i-1]:  
            lbasZ[i-1]= lAll[i]      
            lbasZAl[i-1]= lAll[i-1]        
        if i== nVtx- 1:          
            lbasZ[i]= lAll[i]
      
    for i in range(1, nVtx):                              
        if  lAll[i]+ lZo[i] ==  lAll[i-1]+ lZo[i-1] :  
            lAraMx[i-1]=  lAll[i]+ lZo[i] 
            lSouMx[i-1]= 'no'                                       
        if  lAll[i]+ lZo[i]  >  lAll[i-1]+ lZo[i-1] :  
            lAraMx[i-1]=  lAll[i]+ lZo[i]   
            lSouMx[i-1]=  lAll[i-1]+ lZo[i-1]                                                       
        if  lAll[i]+ lZo[i]  <  lAll[i-1]+ lZo[i-1] :            
            lAraMx[i-1]=  lAll[i-1]+ lZo[i-1]      
            lSouMx[i-1]=  lAll[i]+ lZo[i] 
         
    AvAr= 0; lVtxAv= []; lVtxAr= []; lVtxAvTMP= []  
    num= 0; Exx= 0  # 1er Pts / nR2 - 1 
    lLintR[0]= lAll[0]+ lZo[0]  
    lVtxAv.extend([[-hTt, AvAr, lLintR[num]]])   
    for i in range(0, nVtx):  
        if i== nVtx-1:
            break 
        if i== 0:
            if lSouMx[0] != 'no':                               
                if lAraMx[0]==  lAll[0]+ lZo[0]:  
                    num += 1 
                    lLintR[num]= lAraMx[0]    
                    lVtxAv.extend([[lXo[0], AvAr, lLintR[num]]])   
                    num += 1 
                    lLintR[num]= lSouMx[0]; Exx= lSouMx[0]  
                    lVtxAv.extend([[lXo[0], AvAr, lLintR[num]]])              
                if lSouMx[0]==  lAll[0]+ lZo[0]:  
                    num += 1 
                    lLintR[num]= lSouMx[0]   
                    lVtxAv.extend([[lXo[0], AvAr, lLintR[num]]])
                    num += 1                                 
                    lLintR[num]= lAraMx[0]; Exx= lAraMx[0]                
                    lVtxAv.extend([[lXo[0], AvAr, lLintR[num]]])       
            else:  
                num += 1 
                lLintR[num]= lAraMx[0]; Exx= lAraMx[0]     
                lVtxAv.extend([[lXo[0], AvAr, lLintR[num]]])
        if i> 0: 
            if lSouMx[i] != 'no': 
                num += 1   
                lLintR[num]= Exx  
                lVtxAv.extend([[lXo[i], AvAr, lLintR[num]]])           
                if lAraMx[i] != Exx:  
                    num += 1 
                    lLintR[num]= lAraMx[i]; Exx= lLintR[num]  
                    lVtxAv.extend([[lXo[i], AvAr, lLintR[num]]])   
                else:  
                    num += 1 
                    lLintR[num]= lSouMx[i]; Exx= lLintR[num]  
                    lVtxAv.extend([[lXo[i], AvAr, lLintR[num]]])              
            else: 
                num += 1 
                lLintR[num]= lAraMx[i]  
                lVtxAv.extend([[lXo[i], AvAr, lLintR[num]]])
            if lLintR[num]== 0:
                num -= 1 
    num += 1; lLintR[num]= lAll[nVtx-1]+ lZo[nVtx-1]  
    lVtxAv.extend([[hTt, AvAr, lLintR[num]]])       
    nlVtxAv= len(lVtxAv)           

    for i in range(0, nlVtxAv):
        tmp= lVtxAv[i]  
        if nImp== 1:
            G= tmp[0]; C= tmp[1]; D= tmp[2]+ Zoi  
        if nImp== 0:
            Zoi= 0
            G= tmp[0]; C= tmp[1]; D= tmp[2]      
        lVtxAvTMP.extend([[G, C, D]])
    lVtxAv= lVtxAvTMP               
    for i in range(0, nlVtxAv):  
        tmp= lVtxAv[i]  
        G= tmp[0]; D= tmp[2]  
        lVtxAr.extend([[G, lMur, D]])    
    lVtxAv.reverse(); lVtxAr.reverse()       
             
    for i in range(0, nVtx-1):  
        Gc= lXo[i] - llgM[i]/2  
        Dt= lXo[i] + llgM[i]/2        
        basZ= lbasZ[i]  
        nivZ= lAraMx[i] 
        if nImp== 0:   
            Zoi= 0; self.Zoi= 0  
            nivZ= lAraMx[i]                       
        else:  
            nivZ= lAraMx[i]+ Zoi              
        epM= lepM[i]  
        Meneau(vrtx, fac, nfacGdC, Gc, Dt, fEx, fIn, lgd, epd, lgM, epM, hdA, basZ, nivZ, GdC= 0) #   Meneaux 1      
    epM= epd                      
    Gc= -hTt; Dt= -hTt+ lgd 
    basZ= lAll[0] ; nivZ= lAll[0]+ lZo[0]+Zoi      
    Meneau(vrtx, fac, nfacGdC, Gc, Dt, fEx, fIn, lgd, epd, lgM, epM, hdA, basZ, nivZ, GdC= 0)             
    Gc= hTt- lgd; Dt= hTt  
    basZ= lAll[nVtx- 1] ; nivZ= lAll[nVtx- 1]+ lZo[nVtx- 1]+ Zoi
    Meneau(vrtx, fac, nfacGdC, Gc, Dt, fEx, fIn, lgd, epd, lgM, epM, hdA, basZ, nivZ, GdC= 0)     
                               
    for b in range(0, nVtx):  
        if b== 0:   
            hTtG= -hTt+lgd; hTtD= lXo[b]- llgM[0]/2  
        elif b > 0:  
            if b== nVtx- 1:        
                hTtG= lXo[b-1]+ llgM[b-1]/2  
                hTtD= hTt- lgd    
            else:                
                hTtG= lXo[b- 1]+ llgM[b-1]/2   
                hTtD= lXo[b]- llgM[b]/2  
        if self.nImp== 1 and Zoi > 0:           
            basZ= lAll[b]+ lZo[b]+ Zoi- lgd; nivZ= lAll[b]+ lZo[b]+ Zoi    
            Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC= 0)  
            basZ= lAll[b]+ lZo[b]- lgd; nivZ= lAll[b]+ lZo[b] 
            Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC= 0)                        
        if self.nImp== 0:
            basZ= lAll[b]+ lZo[b]- lgd; nivZ= lAll[b]+ lZo[b]                                                                 
            Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC= 0)
        basZ= lAll[b]; nivZ= lAll[b]+ hdA                     
        Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC= 0)    
                                                                             
    if AllViC== True:
        for i in range(0, nVtx):  
            if lAll[i]== 0.1:  
                lAllVi[i]= 0.8
                lAllViC[i]= True
            else:
                lAllVi[i]= 0
                lAllViC[i]= False   
        for b in range(0, nVtx):            
            if lAll[b]== 0.1:  
                lAllVi[b]= AllVi                                     
                if b== 0:  
                    hTtG= -hTt+lgd; hTtD= lXo[b]- llgM[0]/2                                                   
                elif b > 0:   
                    if b== nVtx- 1:  
                        hTtG= lXo[b-1]+ llgM[b-1]/2                        
                        hTtD= hTt- lgd 
                    else:                                             
                        hTtG= lXo[b- 1]+ llgM[b-1]/2  
                        hTtD= lXo[b]- llgM[b]/2    
                nivZ= lAll[b]+ lAllVi[b]; basZ= nivZ- lgd* 2  
                All= lAllVi[b] 
                Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC= 0)                    
                basZE= lAll[b]+ hdA; basZI= lAll[b]- lgd* 2         # /def Vitre > basZE et nivZ (basZI Sinon Err)
                nivZ= lAll[b]+ AllVi- lgd* 2; fEx= lMur- epd
                Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 0)
    if self.IIdem== True:   
        self.ImpTyp1= self.ImpTyp0; self.ImpTyp2= self.ImpTyp0; self.ImpTyp3= self.ImpTyp0; self.ImpTyp4= self.ImpTyp0
    lIdes.extend([self.ImpTyp0, self.ImpTyp1, self.ImpTyp2, self.ImpTyp3, self.ImpTyp4])    
    if self.OIdem== True:    
        self.OuvTyp1= self.OuvTyp0; self.OuvTyp2= self.OuvTyp0; self.OuvTyp3= self.OuvTyp0; self.OuvTyp4= self.OuvTyp0
    lOdes.extend([self.OuvTyp0, self.OuvTyp1, self.OuvTyp2, self.OuvTyp3, self.OuvTyp4])  
    hTtG= 0; hTtD= 0; hTC= 0; nPos= -1   
                         
    for b in range(0, nVtx):             
        if b== 0:   
            hTtG= -hTt+lgd; hTtD= lXo[b]- llgM[0]/2                 
        elif b > 0:   
            if b== nVtx- 1:  
                hTtG= lXo[b-1]+ llgM[b-1]/2  
                hTtD= hTt- lgd                               
            else:                
                hTtG= lXo[b- 1]+ llgM[b-1]/2   
                hTtD= lXo[b]- llgM[b]/2                                              
        if lAllViC[b]== True:
            basZE= lAll[b]+ lAllVi[b]    
            basZI= lAll[b]+ lAllVi[b]+ hOA  
            nivZ= basZE; basZ= nivZ- lgd* 2
        elif lAllViC[b]== False:                                                              
            basZE= lAll[b]+ hdA   
            basZI= lAll[b]+ hdA+ hOA  
        if lOdes[b] != '0':   
            hTC= hTtG+ (hTtD-hTtG)/2
            nivZ= lAll[b]+ lZo[b]- lgd
            if lOdes[b]== '3':                   
                for e in range(0,5):  
                    if lOdes[e]== '3': 
                        epd= .08; self.epd= epd*100; epOC= .035; self.epO= epOC*100                          
                        break  
                    else:   
                        epd= .05; epO= .05; self.epd= epd*100; self.epO= epO*100                 
            if lOdes[b]== '1':   
                fEx= lMur-epO + 0.015; fIn= lMur + 0.015    
                Ouvrant(vrtx, fac, hTt, hTtG, hTtD, lgd, hdA, lgO, hOA, nivZ, fEx, fIn, All, basZE, basZI, basZ, TourD= 1)  
                AppuiSeuil(vrtx, fac, hTtG, hTtD, fEx, basZE, Rep= 1)                                               
                Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 1)               
            if lOdes[b]== '2':    
                fEx= lMur-epO + 0.015; fIn= lMur + 0.015                                                                          
                tmp= hTtD; hTtD= hTC                  
                Ouvrant(vrtx, fac, hTt, hTtG, hTtD, lgd, hdA, lgO, hOA, nivZ, fEx, fIn, All, basZE, basZI, basZ, TourD= 1)                    
                Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 1)
                GdLoup(vrtx, fac, hTC, fEx, basZE, nivZ)
                hTtD= hTC- .002  
                AppuiSeuil(vrtx, fac, hTtG, hTtD, fEx, basZE, Rep= 1)                                       
                hTtG= hTC; hTtD= tmp  
                Ouvrant(vrtx, fac, hTt, hTtG, hTtD, lgd, hdA, lgO, hOA, nivZ, fEx, fIn, All, basZE, basZI, basZ, TourD= 1)
                Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 1)
                hTtG= hTC+ .002                     
                AppuiSeuil(vrtx, fac, hTtG, hTtD, fEx, basZE, Rep= 1)               
            if lOdes[b]== '3':    
                fEx= lMur- epd+ .005; fIn= fEx+ epOC  
                tmp= hTtD; hTtD= hTC+ lgO/2  
                Ouvrant(vrtx, fac, hTt, hTtG, hTtD, lgd, hdA, lgO, hOA, nivZ, fEx, fIn, All, basZE, basZI, basZ, TourD= 1)
                Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 3)
                hTtG= hTC- lgO/2; hTtD= tmp   
                fIn= lMur- .005; fEx= fIn- epOC  
                Ouvrant(vrtx, fac, hTt, hTtG, hTtD, lgd, hdA, lgO, hOA, nivZ, fEx, fIn, All, basZE, basZI, basZ, TourD= 1)
                Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 3)
            if lOdes[b]== '4':                              
                basZE= lAll[b]+ lAllVi[b]; nivZ= lAll[b]+ lZo[b]- lgd               
                basZI= lAll[b]+ lAllVi[b]+ hdA+ hOA; fEx= lMur- epd; fIn= lMur-lgd/2
                Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 0)  
                           
    if self.nImp== 1 and Zoi > 0:                 
        for b in range(0, nVtx):                                                 
            if b== 0:   
                hTtG= -hTt+lgd; hTtD= lXo[b]- llgM[0]/2  
            elif b > 0:   
                if b== nVtx- 1:   
                    hTtG= lXo[b-1]+ llgM[b-1]/2                    
                    hTtD= hTt- lgd  
                else:                
                    hTtG= lXo[b- 1]+ llgM[b-1]/2   
                    hTtD= lXo[b]- llgM[b]/2               
            basZE= lAll[b]+ lZo[b]
            basZI= lAll[b]+ lZo[b]+ hOA                
            nivZ= lAll[b]+ lZo[b]+ Zoi- lgd 
            epO= .05; fEx= lMur-epO + 0.015; fIn= lMur + 0.015
            if lIdes[b]!= '0': #                   
                if lIdes[b]== '1':   
                    Ouvrant(vrtx, fac, hTt, hTtG, hTtD, lgd, hdA, lgO, hOA, nivZ, fEx, fIn, All, basZE, basZI, basZ, TourD= 1)
                    AppuiSeuil(vrtx, fac, hTtG, hTtD, fEx, basZE, Rep= 1)                   
                    Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 1)
                if lIdes[b]== '2':  
                    basZE= lAll[b]+ lZo[b]
                    basZI= lAll[b]+ lZo[b]+ hOA                
                    nivZ= lAll[b]+ lZo[b]+ Zoi- lgd; fEx= lMur- epd
                    Vitre(vrtx, fac, nfacVit, hTtG, hTtD, lgO, epd, epO, epOC, fEx, fIn, basZE, basZI, nivZ, Rep= 0) 
                                                       
    if self.TtDecoch== True:   
        self.OuvTyp0='0'; self.OuvTyp1='0'; self.OuvTyp2='0'; self.OuvTyp3='0'; self.OuvTyp4='0'
        self.ImpTyp0='0'; self.ImpTyp1='0'; self.ImpTyp2='0'; self.ImpTyp3='0'; self.ImpTyp4='0'
        for i in range(0,nVtx):            
            lOdes[i]= '0'; lIdes[i]= '0'                             
        AllViC= False  
                           
    if self.GdeCC== True:           
            for b in range(0, nVtx):  
                if self.GdeCC== True and lAllViC[b]== False: 
                    if lAll[b]== 0 or lAll[b]== .45:  
                        lGdeC[b]= 1  
                        lGdeCC[b]=True
                    else:
                        lGdeC[b]= 0  
                        lGdeCC[b]= False
            MemnivZ= 0; hTtAx= 0; eBal= .01; nBalSAxes= 0; MembasZ= 0; nBal= 0             
            Jeu= .02
            for i in range(0, nVtx):                                         
                lepM[nVtx-1]= lepM[nVtx-2]                                                  
                if lGdeCC[i]== True:  
                    if lAll[i]== 0 or lAll[i]== .45:                      
                        nivZ= lGdeC[i]; basZ= nivZ- 0.1   
                        fEx= lMur- lepM[i]- .05- Jeu; fIn= fEx+ .04
                        MemnivZ= basZ  
                    if i== 0:  
                        hTtG= -hTt; hTtD= lXo[0]
                        hTtAx= (lXo[0]- 0.055)- (-hTt+ 0.055)                       
                    elif i== nVtx- 1:   
                        hTtG= lXo[i-1]; hTtD= hTt
                        hTtAx= (hTt- 0.055)- (lXo[i-1]+ 0.055)                                              
                    else:  
                        hTtG= lXo[i-1]; hTtD= lXo[i]
                        hTtAx= lXo[i]- 0.055- lXo[i-1]+ 0.055
                    if nVtx== 1 and i== 0:           
                        hTtG= -hTt; hTtD= hTt
                        hTtAx= (hTt- 0.055)- (-hTt+ 0.055)                        
                    All= lGdeC[i]                        
                    Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC= 1)

                    if hTtAx < 0.3:  
                        print("hTtAx < .3 Suivant Pas Dessin=", hTtAx)
                        break                                                              
                    nInterv= int(hTtAx/ 0.11)                    
                    nBal= nInterv + 1         
                    AxeBal= hTtAx / (nBal-1)  
                    if AxeBal > .12:
                        nInterv += 1; nBal= nInterv + 1 
                        AxeBal= hTtAx / nInterv
                        nBal= int(nBal)
                    AxeBal= round(AxeBal,4)                 
                    basZ= lAll[i]+ .03; nivZ= MemnivZ; MembasZ= basZ  
                    fEx= fEx +.005; fIn= fEx+ .03                      
                    for k in range(1, nBal+1):                       
                        if i== 0 and k== 1:  
                            Gc= -hTt+ 0.05   
                            Dt= Gc + eBal                              
                        elif i> 0 and k== 1:  
                            Gc= lXo[i-1]+ 0.05  
                            Dt= Gc + eBal    
                        else:   
                            Gc += AxeBal   
                            Dt= Gc + eBal
                            if Gc > lXo[i]:                                
                                break                             
                        Meneau(vrtx, fac, nfacGdC, Gc, Dt, fEx, fIn, lgd, epd, lgM, epM, hdA, basZ, nivZ, GdC= 1)
                 
                    basZ= MembasZ+.06; nivZ= basZ+ .04                
                    fEx= fEx + .01; fIn= fEx+ .01
                    Traverse(vrtx, fac, nfacGdC, hTt, hTtG, hTtD, lgd, nivZ, Zoi, fEx, fIn, All, basZ, nImp, GdC= 1)

    if self.YoC== True: 
        a= len(vrtx)
        n= 0
        fEx= 0; fIn= lMur 
        nivLint= lAll[0]+ lZo[0]+ (self.Zoi/100); nivZ= nivLint + 1                 
        for Fac2 in range(1, 3):  
            if Fac2== 1:
                AvAr= fEx
            else:
                AvAr= fIn        
            lVtx.extend([[-hTt-2, AvAr, -1], [-hTt, AvAr, lAll[0]]])  
            vrtx.extend([[-hTt-2, AvAr, -1], [-hTt, AvAr, lAll[0]]])  
            if nVtx== 1:  
                  lVtx.extend([[hTt, AvAr, lAll[0]]])  
                  vrtx.extend([[hTt, AvAr, lAll[0]]]) 
            else:   
                  lVtx.extend([[lXo[0], AvAr, lAll[0]]]) 
                  vrtx.extend([[lXo[0], AvAr, lAll[0]]])           
            for i in range(1, nVtx):                                 
                if lAll[i]== lAll[i-1]:   
                    if lXo[i]== hTt- .025:  
                        lVtx.extend([[hTt, AvAr, lAll[i]]])  
                        vrtx.extend([[hTt, AvAr, lAll[i]]])  
                    else:  
                        lVtx.extend([[lXo[i], AvAr, lAll[i]]])   
                        vrtx.extend([[lXo[i], AvAr, lAll[i]]])                       
                else:     
                    lVtx.extend([[lXo[i-1], AvAr, lAll[i]]])  
                    vrtx.extend([[lXo[i-1], AvAr, lAll[i]]])  
                    if lXo[i]== hTt- .025:   
                        lVtx.extend([[hTt, AvAr, lAll[i]]])  
                        vrtx.extend([[hTt, AvAr, lAll[i]]])                        
                    else:
                        lVtx.extend([[lXo[i], AvAr, lAll[i]]])   
                        vrtx.extend([[lXo[i], AvAr, lAll[i]]])                                                                           
            lVtx.extend([[hTt+2, AvAr, -1]]) 
            vrtx.extend([[hTt+2, AvAr, -1]])  
            lVtx.extend([[hTt+2, AvAr, nivZ]])           
            vrtx.extend([[hTt+2, AvAr, nivZ]])            
             
            if Fac2== 2:  
                lVtx.extend(lVtxAr)  
                vrtx.extend(lVtxAr)                
            else:   
                lVtx.extend(lVtxAv)  
                vrtx.extend(lVtxAv)  
            lVtx.extend([[-hTt-2, AvAr, nivZ]])  
            vrtx.extend([[-hTt-2, AvAr, nivZ]])                                
        nT= len(vrtx)         
        nlVtx= len(lVtx)  
        nvrM= nT- a  
        m= int(nvrM/2)  
        nR2= m-2
        for i in range(0, nlVtx):   
            tmp= lVtx[i]; ValhTt= tmp[0]
            if ValhTt== hTt:
                nR= i
                break    
        ma= m+a  
        if nR== 10:  
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a, 9+a, 10+a, 11+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a, m+9+a, m+10+a, m+11+a]])
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a, 9+a, 10+a, 11+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a, m+9+a, m+10+a, m+11+a]])

        if nR== 9: 
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a, 9+a, 10+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a, m+9+a, m+10+a]])
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a, 9+a, 10+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a, m+9+a, m+10+a]])
                                   
        if nR== 8:  
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a, 9+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a, m+9+a]])
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a, 9+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a, m+9+a]])
        if nR== 7:   
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a]])
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a, 8+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a, m+8+a]])        
        if nR== 6:  
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a]])            
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a, 7+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a, m+7+a]])        
        if nR== 5:   
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a]])            
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a, 6+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a, m+6+a]])
        if nR== 4:  
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a]])            
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a, 5+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a, m+5+a]])
        if nR== 3:   
            lFac.extend([[0+a, 1+a, 2+a, 3+a, 4+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a]])            
            fac.extend([[0+a, 1+a, 2+a, 3+a, 4+a],[m+a, m+1+a, m+2+a, m+3+a, m+4+a]])            
        if nR== 2:  # m=  
            lFac.extend([[0+a, 1+a, 2+a, 3+a],[m+a, m+1+a, m+2+a, m+3+a]])            
            fac.extend([[0+a, 1+a, 2+a, 3+a],[m+a, m+1+a, m+2+a, m+3+a]]) 

        if nlVtxAv== 10:  
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a, nR+7+a, nR+8+a, nR+9+a, nR+10+a, nR+11+a, nR+12+a, nR+13+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma, nR+7+ma, nR+8+ma, nR+9+ma, nR+10+ma, nR+11+ma, nR+12+ma, nR+13+ma]])                    
        if nlVtxAv== 9: 
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a, nR+7+a, nR+8+a, nR+9+a, nR+10+a, nR+11+a, nR+12+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma, nR+7+ma, nR+8+ma, nR+9+ma, nR+10+ma, nR+11+ma, nR+12+ma]])        
        if nlVtxAv== 8:  
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a, nR+7+a, nR+8+a, nR+9+a, nR+10+a, nR+11+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma, nR+7+ma, nR+8+ma, nR+9+ma, nR+10+ma, nR+11+ma]])
        if nlVtxAv== 7:  
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a, nR+7+a, nR+8+a, nR+9+a, nR+10+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma, nR+7+ma, nR+8+ma, nR+9+ma, nR+10+ma]])        
        if nlVtxAv== 6:
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a, nR+7+a, nR+8+a, nR+9+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma, nR+7+ma, nR+8+ma, nR+9+ma]])
        if nlVtxAv== 5:
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a, nR+7+a, nR+8+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma, nR+7+ma, nR+8+ma]])
        if nlVtxAv== 4:
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a, nR+7+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma, nR+7+ma]])            
        if nlVtxAv== 3:  
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a, nR+6+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma, nR+6+ma]])
        if nlVtxAv== 2:
            fac.extend([[nR+2+a, nR+3+a, nR+4+a, nR+5+a],[nR+2+ma, nR+3+ma, nR+4+ma, nR+5+ma]])                              
                                                                     
        lFac.extend([[nR+a, nR+1+a, nR+2+a, nR+3+a],[0+a, 1+a, nR2+a, nR2+1+a]])  
        lFac.extend([[nR+ma, nR+1+ma, nR+2+ma, nR+3+ma],[ma, 1+ma, nR2+ma, nR2+1+ma]])       
        fac.extend([[nR+a, nR+1+a, nR+2+a, nR+3+a],[0+a, 1+a, nR2+a, nR2+1+a]])  
        fac.extend([[nR+ma, nR+1+ma, nR+2+ma, nR+3+ma],[ma, 1+ma, nR2+ma, nR2+1+ma]])          
                                
        for i in range(1, nR): 
            lFac.extend([[i+a, i+1+a, i+1+ma, i+ma]]) 
            fac.extend([[i+a, i+1+a, i+1+ma, i+ma]])
               
        for i in range(nR+3, nR2): 
            lFac.extend([[i+a, i+1+a, i+1+ma, i+ma]]) 
            fac.extend([[i+a, i+1+a, i+1+ma, i+ma]])
               
        lFac.extend ([[nR+a, nR+ma, nR+3+ma, nR+3+a]]) 
        lFac.extend ([[1+a, nR2+a, nR2+ma, 1+ma]])  
        fac.extend ([[nR+a, nR+ma, nR+3+ma, nR+3+a]])  
        fac.extend ([[1+a, nR2+a, nR2+ma, 1+ma]]) 
                
        f= len(fac) 
        nFMurFac= 8+ 2+ (nR- 1)+ (nlVtxAv- 1)  
        for i in range(1,nFMurFac+ 1):  
            nfMurTbl.extend([f- i])  
       
    mesh = bpy.data.meshes.new(name='Menuiseries')
    mesh.from_pydata(vrtx,[],fac)    
    v= len(vrtx); f= len(fac)

    if   self.mtr=='1':mesh.materials.append(MatC('Pvc', 1.0,1.0,1.0))
    elif self.mtr=='2':mesh.materials.append(MatC('Bois',0.8,0.2,0))
    elif self.mtr=='3':mesh.materials.append(MatC('Alu', 0.66, 0.66, 0.66))  
    mesh.materials.append(MatC('Facade', 1, 0, 0)) 
    for i in nfMurTbl:       
        mesh.polygons[i].material_index=2    
    mesh.materials.append(MatC('Verre', 0.35, 0.45, 1))    
    bpy.data.materials["Verre"].alpha=0.5   
    for i in nfacVit:
        mesh.polygons[i].material_index= 3         
    mesh.materials.append(MatC('GdCorps', 0, 0.8,0))    
    for i in nfacGdC:
        mesh.polygons[i].material_index= 3
            
    mesh.update(calc_edges=True)
    from bpy_extras import object_utils
    return object_utils.object_data_add(context, mesh, operator=None)
    if  bpy.context.mode!='EDIT_MESH':
        bpy.ops.object.editmode_toggle()
        bpy.ops.object.editmode_toggle()
    
#------------------------------------
class menuiseries(bpy.types.Operator):
    bl_idname = "mesh.add_menuiseries"
    bl_label = "menuiseries"
    bl_description = "Creer menuiseries"
    bl_options = {'REGISTER', 'UNDO'}
    Valr = EnumProperty(items = (('1',"60x60 A Frappe 1 vantail",""),
                                ('2',"180x130 A Frappe 2 Vantaux",""),
                                ('3',"305x220 A Frappe 3 Vantaux Allege Vitre",""),
                                ('4',"405x220 A Frappe 4 Vantaux",""),
                                ('5',"505x220 A Frappe 5 Vantaux 3 F-2 PF",""),
                                ('6',"505x220 A Frappe 5 Vantaux 3 PF-2 F",""),
                                ('7',"505x220 A Frappe 5 Vantaux 1 PF-3 F-1 PF",""),
                                ('8',"505x220 A Frappe 5 Vantaux 5 F en Escalier HG",""),                                
                                ('9',"505x220 A Frappe 5 Vantaux 5 F en Escalier BG",""),
                                ('10',"505x220 A Frappe 5 Vtx en Escalier BG MenoLint",""),
                                ('11',"505x220 A Frappe 5 Vantaux Inegaux","")),
                                 name="")
    memo=Valr
    nVtx=IntProperty(name='nbre d Ouvertures', min=1,max= 5, default= 1, description='Ouvertures Separees Par Meneaux ')        
    nImp=IntProperty(name='nbre Imposte', min=0,max= 1, default= 0, description='Une Imposte Maxi')
    
    OuvTyp0=EnumProperty(items =(('1',"F1V",""),('2',"F2V",""),('3',"C2V",""),('4',"FIX",""),('0',"VID","")),name="",default='4')
    OuvTyp1=EnumProperty(items =(('1',"F1V",""),('2',"F2V",""),('3',"C2V",""),('4',"FIX",""),('0',"VID","")),name="",default='2')
    OuvTyp2=EnumProperty(items =(('1',"F1V",""),('2',"F2V",""),('3',"C2V",""),('4',"FIX",""),('0',"VID","")),name="",default='1')
    OuvTyp3=EnumProperty(items =(('1',"F1V",""),('2',"F2V",""),('3',"C2V",""),('4',"FIX",""),('0',"VID","")),name="",default='2')
    OuvTyp4=EnumProperty(items =(('1',"F1V",""),('2',"F2V",""),('3',"C2V",""),('4',"FIX",""),('0',"VID","")),name="",default='4')
    
    ImpTyp0=EnumProperty(items =(('1',"F1V",""),('2',"FIX",""),('0',"VID","")),name="",default='1')
    ImpTyp1=EnumProperty(items =(('1',"F1V",""),('2',"FIX",""),('0',"VID","")),name="",default='2')
    ImpTyp2=EnumProperty(items =(('1',"F1V",""),('2',"FIX",""),('0',"VID","")),name="",default='1')
    ImpTyp3=EnumProperty(items =(('1',"F1V",""),('2',"FIX",""),('0',"VID","")),name="",default='2')
    ImpTyp4=EnumProperty(items =(('1',"F1V",""),('2',"FIX",""),('0',"VID","")),name="",default='1')
    
    det=BoolProperty(name='CHANGE VALEURS DEFAUT:',default=True) 
    CadOUV=BoolProperty(name='LARGEUR des OUVERTURES:      Voir Menu MODIFIER Largeur....',default=True)
    CadImp=BoolProperty(name='IMPOSTES:',default=True) 
    CadLxHOuv=BoolProperty(name='FENETRES - PORTES FENETRES:',default=True) 
 
    All= IntProperty(name='',min= 0,max= 220,default= 90,description='Si Allege= 0, 10, 60 > GdCorps a Cocher')
    All0= IntProperty(name='',min= 0,max= 220,default= 90,description='All 1e F-PF')
    All1= IntProperty(name='',min= 0,max= 220,default= 10,description='All 2e F-PF')
    All2= IntProperty(name='',min= 0,max= 220,default= 90,description='All 3e F-PF')
    All3= IntProperty(name='',min= 0,max= 220,default= 0,description='All 4 F-PF')
    All4= IntProperty(name='',min= 0,max= 220,default= 90,description='All 5e F-PF')
    
    Yo= bpy.props.FloatProperty(name='epr Mur',min=10,max= 100,default= 35,description='Epr Mur'); YoC= BoolProperty(name='',default= False)
    AllVi= IntProperty(name='Htr All Vitre',min= 0,max= 220,default= 90,description='Htr Allege Vitre= 80/ All BA= 10 Total= 90')
    
    GdeC= IntProperty(name='GCorps',min= 20,max= 150,default= 100,description='SI Allege= 0')
    AllViC= BoolProperty(name='',default= False); GdeCC= BoolProperty(name='',default= False)   
   
    lgd= IntProperty(name='', min=5,max=10, default= 5, description='/Facade lgr dormant / 3Cotes')  
    epd= bpy.props.FloatProperty(name='',min=3,max=10,default= 5,description='Epr Dormant (Varie/Coulissant')
    hdA= IntProperty(name='',min=1,max= 10,default= 6,description='Htr Bas dormant // Appui')  
    
    lgO= IntProperty(name='', min=5,max=10, default= 5, description='/Facade lgr Ouvrant / 3Cotes')   
    epO= bpy.props.FloatProperty(name='',min=3,max=20,default= 5,description='Epr Ouvrant (Varie/Coulissant')
    epOC= bpy.props.FloatProperty(name='',min=3.5,max=20,default= 3.5,description='Epr Vantaux Coulissants')     
    hOA= IntProperty(name='',min=1,max= 10,default= 6,description='Htr Bas Ouvrant // Appui')  
        
    mtr= EnumProperty(items =(('1',"PVC",""),('2',"BOIS",""),('3',"ALU","")),name=" Menuiseries:",default='1')
        
    XoT= bpy.props.FloatProperty(name='Lgr Totale en Tableaux',min=1,max=1500,default= 60,description='Totale Tableaux G.O')
    Xo0= bpy.props.FloatProperty(name='',min=1,max=1000,default= 60,description='Lgr 1e F-PF > 20cm Mini')
    Xo1= bpy.props.FloatProperty(name='',min=1,max=1000,default= 60,description='Lgr 2e F-PF')
    Xo2= bpy.props.FloatProperty(name='',min=1,max=1000,default= 60,description='Lgr 3e F-PF > 20cm Mini')
    Xo3= bpy.props.FloatProperty(name='',min=1,max=1000,default= 60,description='Lgr 4e F-PF')
    Xo4= bpy.props.FloatProperty(name='',min=1,max=1000,default= 60,description='Lgr 5e F-PF')
    
    ZoAff= IntProperty(name='',min=20,max=500,default= 130,description='Htr en Tableaux F et PF')
    Zo0= IntProperty(name='',min=20,max=500,default= 130,description='Htr 1e F-PF')
    Zo1= IntProperty(name='',min=20,max=500,default= 220,description='Htr 2e F-PF')    
    Zo2= IntProperty(name='',min=20,max=500,default= 130,description='Htr 3e F-PF')
    Zo3= IntProperty(name='',min=20,max=500,default= 210,description='Htr 4e F-PF')
    Zo4= IntProperty(name='',min=20,max=500,default= 130,description='Htr 5e F-PF')
    nivLintFPF= IntProperty(name='LINTEAU FPF+',min=0,max=700,default= 220,description='GELER Niveau MAXI LINTEAU F-PF + COCHER')
    nivLintFPFC= BoolProperty(name='',default=False)  
    
    Zoi= IntProperty(name='htr Imposte',min=0,max=200,default= 0,description='Htr Imposte (0 si n Imposte a 0')
    Egalise= EnumProperty(items =(('0',"Lgr TOTALE TABLEAUX et/ou LARGEUR TRAVEES / TOTALE A FIXER",""),('1',"Lgr des Travees LIBRES Avec Largeur Totale RECALCULEE",""),('2',"EGALISER ENTR'AXES MENEAUX / LARGEUR TOTALE (lgr Verre)","")),name="",default='1')
        
    OIdem= BoolProperty(name='',default=False)  
    IIdem= BoolProperty(name='',default=False)  
    AllIdem= BoolProperty(name='',default=False)      
    hZoIdem= BoolProperty(name='',default=False)  
    TtDecoch= BoolProperty(name='',default=False)
    
    lgM= IntProperty(name='', min=5,max=25, default= 5, description='')
    lgM0= IntProperty(name='', min=5,max=25, default= 5, description='/Facade lgr 1er Meneau')
    lgM1= IntProperty(name='', min=5,max=25, default= 5, description='/Facade lgr 2e Meneau')
    lgM2= IntProperty(name='', min=5,max=25, default= 5, description='/Facade lgr 3e Meneau')
    lgM3= IntProperty(name='', min=5,max=25, default= 5, description='/Facade lgr 4e Meneau')
    lgM4= IntProperty(name='', min=5,max=25, default= 5, description='Pour Index Err')
    
    epM= IntProperty(name='', min=5,max=25, default= 5, description='')
    epM0= IntProperty(name='', min=5,max=25, default= 5, description='/Facade epr 1er Meneau')    
    epM1= IntProperty(name='', min=5,max=25, default= 5, description='/Facade epr 2e Meneau')
    epM2= IntProperty(name='', min=5,max=25, default= 5, description='/Facade epr 3e Meneau')
    epM3= IntProperty(name='', min=5,max=25, default= 5, description='/Facade epr 4e Meneau')
    epM4= IntProperty(name='', min=5,max=25, default= 5, description='Pour Index Err')
    lgMepM= BoolProperty(name='',default=False)
    lgMepM8= BoolProperty(name='',default=False)
                            
    Choix= StringProperty(name='',description="n", default= "")

    def draw(self, context):
        layout = self.layout
        layout.prop(self,'Valr')   
        box=layout.box()     
        row= box.row(); row.prop(self,'nVtx'); row.prop(self,'nImp')
                                                                        
        box=layout.box()   
        box.prop(self,'CadOUV')  
        if self.CadOUV== True:        
            box.prop(self,'Egalise')  
            row= box.row(); row.prop(self,'XoT')         
            row= box.row()                      
            for i in range(0,self.nVtx): 
                row.prop(self,'Xo'+str(i))  
            if self.Egalise== '0':
                if self.nVtx== 5 or self.nVtx== 3:
                    row= box.row(); row.label('                                                   BLOQUE')
                elif self.nVtx== 2:
                    row= box.row(); row.label('                     BLOQUE')
                elif self.nVtx== 4:
                    row= box.row(); row.label('     BLOQUE')
                                
        box=layout.box()   
        box.prop(self,'CadImp')               
        if self.CadImp== True:                                    
            row= box.row(); row.prop(self,'Zoi'); row.label('TYPES IMPOSTES Idem 1ere'); row.prop(self,'IIdem')
            row= box.row() 
            for i in range(0,self.nVtx):
                row.prop(self,'ImpTyp'+str(i))                                                                       

        box=layout.box()   
        box.prop(self,'CadLxHOuv')   
        if self.CadLxHOuv== True:                                    
            row= box.row(); row.label('TYPES Idem au 1er'); row.prop(self,'OIdem')
            row.prop(self,'nivLintFPF'); row.prop(self,'nivLintFPFC')                       
            row= box.row()   
            for i in range(0,self.nVtx):            
                row.prop(self,'OuvTyp'+str(i))               
            row= box.row()    
            for i in range(0,self.nVtx):   
                row.prop(self,'Zo'+str(i))                           
            row= box.row(); row.label('AllegeS Idem a 1ere'); row.prop(self,'AllIdem')
            row.label('HauteurS Idem a 1ere'); row.prop(self,'hZoIdem')           
            row= box.row()    
            for i in range(0,self.nVtx):   
                row.prop(self,'All'+str(i))               
            row= box.row()                               
            if self.TtDecoch== False:
                row.label('COCHER & ENLEVER Tous OUVRANTS + DECOCHEZ (Refresh)'); row.prop(self,'TtDecoch')
            if self.TtDecoch== True:
                row.label('POUR RAFRAICHIR DESSIN: DECOCHEZ  >>>>'); row.prop(self,'TtDecoch') 
            row= box.row(); row.prop(self,'Yo'); row.label('    AFFICHE  MUR de FACADE'); row.prop(self,'YoC')           
            row= box.row(); row.prop(self,'AllVi'); row.prop(self,'AllViC'); row.label('AFFICHE GARDE de CORPS'); row.prop(self,'GdeCC')
            
        box=layout.box()         
        box.prop(self,'det')                                 
        if self.det== True:
            box.prop(self,'mtr')  
            row= box.row(); row.label('Cotes  >>'); row.label('Lgr Face'); row.label('    Epr'); row.label('Ht/Seuil')   
            row= box.row(); row.label('Dormant >'); row.prop(self,'lgd'); row.prop(self,'epd'); row.prop(self,'hdA')
            row= box.row(); row.label('Ouvrant >'); row.prop(self,'lgO'); row.prop(self,'epO'); row.prop(self,'hOA')
            if self.nVtx > 1:                 
                row= box.row(); row.label('Sections Meneaux 5x5:'); row.prop(self,'lgMepM')
                row.label('Sections Meneaux 5x8:'); row.prop(self,'lgMepM8')                
                row= box.row(); row.label('Largeur:')            
                for i in range(0,self.nVtx-1):  
                    row.prop(self,'lgM'+str(i))  
                row= box.row(); row.label('Epaisseur:')
                for i in range(0,self.nVtx-1):
                    row.prop(self,'epM'+str(i))             
#-----------------------------
    def execute(self, context):
        if self.memo!=self.Valr:
#            Prs(self)
            Valr(self)
            self.memo=self.Valr
        CreObjet(self,context)
        return {'FINISHED'}
#------------------------------------

def menu_func_menuiseries(self, context):
    self.layout.operator(menuiseries.bl_idname,text="menuiseries",icon="MOD_LATTICE")
def register():
    bpy.utils.register_class(menuiseries)
    bpy.types.INFO_MT_mesh_add.append(menu_func_menuiseries)
def unregister():
    bpy.utils.unregister_class(menuiseries)
    bpy.types.INFO_MT_mesh_add.remove(menu_func_menuiseries)
if __name__ == '__main__':
    register()